package com.safeway.epe.offersdataproducer.mapper;

import com.safeway.epe.offersdataproducer.bomodel.*;
import com.safeway.epe.offersdataproducer.domodel.*;
import org.mapstruct.CollectionMappingStrategy;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;

@Mapper(collectionMappingStrategy = CollectionMappingStrategy.TARGET_IMMUTABLE, componentModel = "spring")
public interface DoToBoMapper {
    @Mapping(target="offersBO",source="offersDO")
    OffersDataBO map(OffersDataDO offersDataDO);

    @Mapping(target="rulesBO",source="rulesDO")
    @Mapping(target="infoBO",source="infoDO")
    OffersBO map(OffersDO offersDO);

    @Mapping(target="idBO",source="idDO")
    @Mapping(target = "terminalsBO",source="terminalsDO")
    InfoBO map(InfoDO infoDO);

    IdBO map(IdDO idDO);

    @Mapping(target="benefitBO",source="benefitDO")
    RulesBO map(RulesDO rulesDO);

    @Mapping(target = "pointsBO",source="pointsDO")
    @Mapping(target = "discountBO",source="discountDO")
    BenefitBO map(BenefitDO BenefitDO);

    @Mapping(target = "discountTierBO",source="discountTierDO")
    DiscountBO map(DiscountDO DiscountDO);

    DiscountTierBO map(DiscountTierDO discountTierDO);

    PointsBO map(PointsDO pointsDO);

}
