package com.safeway.epe.offersdataproducer.resource;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.safeway.epe.offersdataproducer.appconfiguration.AppConfigs;
import com.safeway.epe.offersdataproducer.domodel.OffersDataDO;
import com.safeway.epe.offersdataproducer.service.OffersDataProducerService;
import org.apache.kafka.clients.producer.RecordMetadata;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.concurrent.Future;

@RestController
@RequestMapping(AppConfigs.CLASS_LEVEL_PRODUCER_URL)
public class OffersDataProducerResource {
    @Autowired
    private OffersDataProducerService offersDataProducerService;
    @PostMapping(AppConfigs.CLASS_LEVEL_PRODUCER_URL)
    @ResponseStatus(HttpStatus.CREATED)
    public ResponseEntity<Future<RecordMetadata>> publishOfferEvent(@RequestBody OffersDataDO offersDataDO) throws JsonProcessingException {
        Future<RecordMetadata> offerEventStatus = offersDataProducerService.publishOfferEvent(offersDataDO);
        return ResponseEntity.status(HttpStatus.CREATED).body(offerEventStatus);
    }
}
