package com.safeway.epe.offersdataproducer.service.impl;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.safeway.epe.offersdataproducer.bomodel.OffersDataBO;
import com.safeway.epe.offersdataproducer.domodel.OffersDataDO;
import com.safeway.epe.offersdataproducer.dtomodel.OffersDataDTO;
import com.safeway.epe.offersdataproducer.producer.OffersDataProducer;
import com.safeway.epe.offersdataproducer.service.OffersDataProducerService;
import com.safeway.epe.offersdataproducer.transformer.OffersDataBoToDTO;
import com.safeway.epe.offersdataproducer.transformer.OffersDataDoToBo;
import org.apache.kafka.clients.producer.RecordMetadata;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.concurrent.Future;

@Service
public class OffersDataProducerServiceImpl implements OffersDataProducerService {
    public static final Logger logger = LoggerFactory.getLogger(OffersDataProducerServiceImpl.class);
    @Autowired
    private OffersDataBoToDTO offersDataBoToDTO;
    @Autowired
    private OffersDataDoToBo offersDataDoToBo;
    @Autowired
    private OffersDataProducer offersDataProducer;
    @Override
    public Future publishOfferEvent(OffersDataDO offersDataDO) throws JsonProcessingException {
        logger.info("Start :: OffersDataProducerServiceImpl.publishOfferEvent");
        OffersDataBO offersDataBO = offersDataDoToBo.transerToBo(offersDataDO);
        OffersDataDTO offersDataDTO = offersDataBoToDTO.transferToDTO(offersDataBO);
        Future<RecordMetadata> future = offersDataProducer.sendEvent(offersDataDTO);
        logger.info("End :: OffersDataProducerServiceImpl.publishOfferEvent");
        return future;
    }
}
